/// Cutoff frequency must be less than half the sampling frequency.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith,
    Copy
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SignalFilterInvalidCutoffFrequency {
    #[serde(rename = "invalidCutoffFrequency")]
    #[derive_with(with = conjure_object::private::DoubleWrapper)]
    invalid_cutoff_frequency: f64,
    #[serde(rename = "samplingFrequency")]
    #[derive_with(with = conjure_object::private::DoubleWrapper)]
    sampling_frequency: f64,
}
impl SignalFilterInvalidCutoffFrequency {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(invalid_cutoff_frequency: f64, sampling_frequency: f64) -> Self {
        Self::builder()
            .invalid_cutoff_frequency(invalid_cutoff_frequency)
            .sampling_frequency(sampling_frequency)
            .build()
    }
    #[inline]
    pub fn invalid_cutoff_frequency(&self) -> f64 {
        self.invalid_cutoff_frequency
    }
    #[inline]
    pub fn sampling_frequency(&self) -> f64 {
        self.sampling_frequency
    }
}
impl conjure_error::ErrorType for SignalFilterInvalidCutoffFrequency {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "Compute:SignalFilterInvalidCutoffFrequency"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["invalidCutoffFrequency", "samplingFrequency"]
    }
}
